// Downloaded from https://repo.progsbase.com - Code Developed Using progsbase.

function UUIDNilString(){
  var uuid;

  uuid = "00000000-0000-0000-0000-000000000000".split('');

  return uuid;
}
function GenerateUUID4String(random){
  var uuid4;
  var i, n;

  uuid4 = [];
  uuid4.length = 36;

  for(i = 0; i < 36; i = i + 1){
    n = PseudorandomNextIntegerBetween(random, 0, 16);
    uuid4[i] = NumberToHexCharacter(n);
  }

  /* Add hyphens, version and variant info. */
  uuid4[8] = '-';
  uuid4[13] = '-';
  uuid4[14] = '4';
  uuid4[18] = '-';
  uuid4[23] = '-';

  /* 8 means Variant 1. */
  n = 8 + PseudorandomNextIntegerBetween(random, 0, 4);
  uuid4[19] = NumberToHexCharacter(n);

  return uuid4;
}
function IsValidUUID4String(str){
  var valid;
  var i, n;

  valid = true;

  if(str.length == 36){
    if(str[8] == '-' && str[13] == '-' && str[18] == '-' && str[23] == '-'){
      if(str[14] == '4' && IsHexCharacterLowerCase(str[19])){
        n = HexCharacterToNumber(str[19]);

        if(n >= 8){

          for(i = 0; i < 36; i = i + 1){
            if(i != 8 && i != 13 && i != 18 && i != 23){
              if(IsHexCharacterLowerCase(str[i])){
              }else{
                valid = false;
              }
            }
          }
        }else{
          valid = false;
        }
      }else{
        valid = false;
      }
    }else{
      valid = false;
    }
  }else{
    valid = false;
  }

  return valid;
}
function NumberToHexCharacter(n){
  var c;

  c = 'x';
  if(n == 0){
    c = '0';
  }else if(n == 1){
    c = '1';
  }else if(n == 2){
    c = '2';
  }else if(n == 3){
    c = '3';
  }else if(n == 4){
    c = '4';
  }else if(n == 5){
    c = '5';
  }else if(n == 6){
    c = '6';
  }else if(n == 7){
    c = '7';
  }else if(n == 8){
    c = '8';
  }else if(n == 9){
    c = '9';
  }else if(n == 10){
    c = 'a';
  }else if(n == 11){
    c = 'b';
  }else if(n == 12){
    c = 'c';
  }else if(n == 13){
    c = 'd';
  }else if(n == 14){
    c = 'e';
  }else if(n == 15){
    c = 'f';
  }

  return c;
}
function HexCharacterToNumber(c){
  var n;

  n = 0;
  if(c == '0'){
    n = 0;
  }else if(c == '1'){
    n = 1;
  }else if(c == '2'){
    n = 2;
  }else if(c == '3'){
    n = 3;
  }else if(c == '4'){
    n = 4;
  }else if(c == '5'){
    n = 5;
  }else if(c == '6'){
    n = 6;
  }else if(c == '7'){
    n = 7;
  }else if(c == '8'){
    n = 8;
  }else if(c == '9'){
    n = 9;
  }else if(c == 'a' || c == 'A'){
    n = 10;
  }else if(c == 'b' || c == 'B'){
    n = 11;
  }else if(c == 'c' || c == 'C'){
    n = 12;
  }else if(c == 'd' || c == 'D'){
    n = 13;
  }else if(c == 'e' || c == 'E'){
    n = 14;
  }else if(c == 'f' || c == 'F'){
    n = 15;
  }

  return n;
}
function IsHexCharacterLowerCase(c){
  var valid;

  valid = true;

  if(c == '0'){
  }else if(c == '1'){
  }else if(c == '2'){
  }else if(c == '3'){
  }else if(c == '4'){
  }else if(c == '5'){
  }else if(c == '6'){
  }else if(c == '7'){
  }else if(c == '8'){
  }else if(c == '9'){
  }else if(c == 'a'){
  }else if(c == 'b'){
  }else if(c == 'c'){
  }else if(c == 'd'){
  }else if(c == 'e'){
  }else if(c == 'f'){
  }else{
    valid = false;
  }

  return valid;
}
function IsHexCharacterUpperCase(c){
  var valid;

  valid = true;

  if(c == 'A'){
  }else if(c == 'B'){
  }else if(c == 'C'){
  }else if(c == 'D'){
  }else if(c == 'E'){
  }else if(c == 'F'){
  }else{
    valid = false;
  }

  return valid;
}
function IsHexCharacter(c){
  return IsHexCharacterLowerCase(c) || IsHexCharacterUpperCase(c);
}
function test(){
  var failures;

  failures = CreateNumberReference(0);

  testUUID4(failures);

  return failures.numberValue;
}
function testUUID4(failures){
  var uuid4;
  var random;

  random = CreatePseudorandomNumberGenerator(0);

  uuid4 = GenerateUUID4String(random);
  AssertTrue(IsValidUUID4String(uuid4), failures);
  AssertStringEquals("34da695a-9cb9-48b4-a886-04f9725056fa".split(''), uuid4, failures);

  uuid4 = GenerateUUID4String(random);
  AssertTrue(IsValidUUID4String(uuid4), failures);
  AssertStringEquals("2f9319d1-1648-4e70-9707-d27744c32ce5".split(''), uuid4, failures);

  uuid4 = GenerateUUID4String(random);
  AssertTrue(IsValidUUID4String(uuid4), failures);
  AssertStringEquals("7ef4eed7-6092-495e-bc18-987c91c7ff0e".split(''), uuid4, failures);
}
function CreateLinearCongruentialGeneratorNumericalRecipes(seed){
  return CreateLinearCongruentialGeneratorCustom(Math.pow(2, 32), 1664525, 1013904223, seed);
}
function CreateLinearCongruentialGeneratorCustom(modulus, multiplier, increment, seed){
  var lcg;

  lcg = {};
  lcg.m = modulus;
  lcg.a = multiplier;
  lcg.c = increment;
  lcg.x = seed;

  return lcg;
}
function LinearCongruentialGeneratorNextNumber(lcg){
  lcg.x = Math.floor((lcg.a*lcg.x + lcg.c)%lcg.m);
  return lcg.x/lcg.m;
}
function CreatePseudorandomNumberGenerator(seed){
  var prg;

  prg = {};
  prg.lcg = CreateLinearCongruentialGeneratorNumericalRecipes(seed);

  return prg;
}
function PseudorandomNextNumber(prg){
  return LinearCongruentialGeneratorNextNumber(prg.lcg);
}
function PseudorandomNextInteger(prg, n){
  return Math.floor(PseudorandomNextNumber(prg)*n);
}
function PseudorandomNextIntegerBetween(prg, a, b){
  return Math.ceil(a) + Math.floor(PseudorandomNextNumber(prg)*(b - a));
}
function AssertFalse(b, failures){
  if(b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertTrue(b, failures){
  if( !b ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertEquals(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleansEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertCharactersEqual(a, b, failures){
  if(a != b){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringEquals(a, b, failures){
  if( !StringsEqual(a, b) ){
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertNumberArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertEquals(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertBooleanArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertBooleansEqual(a[i], b[i], failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function AssertStringArraysEqual(a, b, failures){
  var i;

  if(a.length == b.length){
    for(i = 0; i < a.length; i = i + 1){
      AssertStringEquals(a[i].string, b[i].string, failures);
    }
  }else{
    failures.numberValue = failures.numberValue + 1;
  }
}
function CreateBooleanReference(value){
  var ref;
  ref = {};
  ref.booleanValue = value;

  return ref;
}
function CreateBooleanArrayReference(value){
  var ref;
  ref = {};
  ref.booleanArray = value;

  return ref;
}
function CreateBooleanArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.booleanArray = [];
  ref.booleanArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.booleanArray[i] = value;
  }

  return ref;
}
function FreeBooleanArrayReference(booleanArrayReference){
  delete(booleanArrayReference.booleanArray);
  delete(booleanArrayReference);
}
function CreateCharacterReference(value){
  var ref;
  ref = {};
  ref.characterValue = value;

  return ref;
}
function CreateNumberReference(value){
  var ref;
  ref = {};
  ref.numberValue = value;

  return ref;
}
function CreateNumberArrayReference(value){
  var ref;
  ref = {};
  ref.numberArray = value;

  return ref;
}
function CreateNumberArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.numberArray = [];
  ref.numberArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.numberArray[i] = value;
  }

  return ref;
}
function FreeNumberArrayReference(numberArrayReference){
  delete(numberArrayReference.numberArray);
  delete(numberArrayReference);
}
function CreateStringReference(value){
  var ref;
  ref = {};
  ref.string = value;

  return ref;
}
function CreateStringReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.string = [];
  ref.string.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.string[i] = value;
  }

  return ref;
}
function FreeStringReference(stringReference){
  delete(stringReference.string);
  delete(stringReference);
}
function CreateStringArrayReference(strings){
  var ref;
  ref = {};
  ref.stringArray = strings;

  return ref;
}
function CreateStringArrayReferenceLengthValue(lengthx, value){
  var ref;
  var i;
  ref = {};
  ref.stringArray = [];
  ref.stringArray.length = lengthx;

  for(i = 0; i < lengthx; i = i + 1){
    ref.stringArray[i] = CreateStringReference(value);
  }

  return ref;
}
function FreeStringArrayReference(stringArrayReference){
  var i;
  for(i = 0; i < stringArrayReference.stringArray.length; i = i + 1){
    delete(stringArrayReference.stringArray[i]);
  }
  delete(stringArrayReference.stringArray);
  delete(stringArrayReference);
}
function StringToNumberArray(string){
  var i;
  var array;

  array = [];
  array.length = string.length;

  for(i = 0; i < string.length; i = i + 1){
    array[i] = string[i].charCodeAt(0);
  }
  return array;
}
function NumberArrayToString(array){
  var i;
  var string;

  string = [];
  string.length = array.length;

  for(i = 0; i < array.length; i = i + 1){
    string[i] = String.fromCharCode(array[i]);
  }
  return string;
}
function NumberArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function BooleanArraysEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function StringsEqual(a, b){
  var equal;
  var i;

  equal = true;
  if(a.length == b.length){
    for(i = 0; i < a.length && equal; i = i + 1){
      if(a[i] != b[i]){
        equal = false;
      }
    }
  }else{
    equal = false;
  }

  return equal;
}
function FillNumberArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillString(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillBooleanArray(a, value){
  var i;

  for(i = 0; i < a.length; i = i + 1){
    a[i] = value;
  }
}
function FillNumberArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillBooleanArrayRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function FillStringRange(a, value, from, to){
  var i, lengthx;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    for(i = 0; i < lengthx; i = i + 1){
      a[from + i] = value;
    }

    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyNumberArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyBooleanArray(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyString(a){
  var i;
  var n;

  n = [];
  n.length = a.length;

  for(i = 0; i < a.length; i = i + 1){
    n[i] = a[i];
  }

  return n;
}
function CopyNumberArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.numberArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyBooleanArrayRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.booleanArray = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function CopyStringRange(a, from, to, copyReference){
  var i, lengthx;
  var n;
  var success;

  if(from >= 0 && from <= a.length && to >= 0 && to <= a.length && from <= to){
    lengthx = to - from;
    n = [];
    n.length = lengthx;

    for(i = 0; i < lengthx; i = i + 1){
      n[i] = a[from + i];
    }

    copyReference.string = n;
    success = true;
  }else{
    success = false;
  }

  return success;
}
function IsLastElement(lengthx, index){
  return index + 1 == lengthx;
}
function CreateNumberArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillNumberArray(array, value);

  return array;
}
function CreateBooleanArray(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillBooleanArray(array, value);

  return array;
}
function CreateString(lengthx, value){
  var array;

  array = [];
  array.length = lengthx;
  FillString(array, value);

  return array;
}
function SwapElementsOfArray(A, ai, bi){
  var tmp;

  tmp = A[ai];
  A[ai] = A[bi];
  A[bi] = tmp;
}


module.exports = {
	UUIDNilString: UUIDNilString,
	GenerateUUID4String: GenerateUUID4String,
	IsValidUUID4String: IsValidUUID4String,
	NumberToHexCharacter: NumberToHexCharacter,
	HexCharacterToNumber: HexCharacterToNumber,
	IsHexCharacterLowerCase: IsHexCharacterLowerCase,
	IsHexCharacterUpperCase: IsHexCharacterUpperCase,
	IsHexCharacter: IsHexCharacter,
	CreateLinearCongruentialGeneratorNumericalRecipes: CreateLinearCongruentialGeneratorNumericalRecipes,
	CreateLinearCongruentialGeneratorCustom: CreateLinearCongruentialGeneratorCustom,
	LinearCongruentialGeneratorNextNumber: LinearCongruentialGeneratorNextNumber,
	CreatePseudorandomNumberGenerator: CreatePseudorandomNumberGenerator,
	PseudorandomNextNumber: PseudorandomNextNumber,
	PseudorandomNextInteger: PseudorandomNextInteger,
	PseudorandomNextIntegerBetween: PseudorandomNextIntegerBetween,
	AssertFalse: AssertFalse,
	AssertTrue: AssertTrue,
	AssertEquals: AssertEquals,
	AssertBooleansEqual: AssertBooleansEqual,
	AssertCharactersEqual: AssertCharactersEqual,
	AssertStringEquals: AssertStringEquals,
	AssertNumberArraysEqual: AssertNumberArraysEqual,
	AssertBooleanArraysEqual: AssertBooleanArraysEqual,
	AssertStringArraysEqual: AssertStringArraysEqual,
	CreateBooleanReference: CreateBooleanReference,
	CreateBooleanArrayReference: CreateBooleanArrayReference,
	CreateBooleanArrayReferenceLengthValue: CreateBooleanArrayReferenceLengthValue,
	FreeBooleanArrayReference: FreeBooleanArrayReference,
	CreateCharacterReference: CreateCharacterReference,
	CreateNumberReference: CreateNumberReference,
	CreateNumberArrayReference: CreateNumberArrayReference,
	CreateNumberArrayReferenceLengthValue: CreateNumberArrayReferenceLengthValue,
	FreeNumberArrayReference: FreeNumberArrayReference,
	CreateStringReference: CreateStringReference,
	CreateStringReferenceLengthValue: CreateStringReferenceLengthValue,
	FreeStringReference: FreeStringReference,
	CreateStringArrayReference: CreateStringArrayReference,
	CreateStringArrayReferenceLengthValue: CreateStringArrayReferenceLengthValue,
	FreeStringArrayReference: FreeStringArrayReference,
	StringToNumberArray: StringToNumberArray,
	NumberArrayToString: NumberArrayToString,
	NumberArraysEqual: NumberArraysEqual,
	BooleanArraysEqual: BooleanArraysEqual,
	StringsEqual: StringsEqual,
	FillNumberArray: FillNumberArray,
	FillString: FillString,
	FillBooleanArray: FillBooleanArray,
	FillNumberArrayRange: FillNumberArrayRange,
	FillBooleanArrayRange: FillBooleanArrayRange,
	FillStringRange: FillStringRange,
	CopyNumberArray: CopyNumberArray,
	CopyBooleanArray: CopyBooleanArray,
	CopyString: CopyString,
	CopyNumberArrayRange: CopyNumberArrayRange,
	CopyBooleanArrayRange: CopyBooleanArrayRange,
	CopyStringRange: CopyStringRange,
	IsLastElement: IsLastElement,
	CreateNumberArray: CreateNumberArray,
	CreateBooleanArray: CreateBooleanArray,
	CreateString: CreateString,
	SwapElementsOfArray: SwapElementsOfArray,
	test: test
};